//+------------------------------------------------------------------+
//|                                              i-DRProjections.mq4 |
//|                                             . aka KimIV |
//|                                              http://www.kimiv.ru |
//| 27.08.2005 v.0.0   $anto$'                             |
//|  Daily Range Projections                                |
//|                               |
//|                                              |
//+------------------------------------------------------------------+
#property copyright "  . aka KimIV"
#property link      "http://www.kimiv.ru"

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 Lime
#property indicator_color2 Red
#property indicator_color3 White

//-------   ------------------------------------------
extern int NumberOfDay = 10; //  

//-------   ------------------------------------------
double MaxDay[];
double MinDay[];
double MidDay[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
void init() {
  SetIndexBuffer(0, MaxDay);
  SetIndexStyle (0, DRAW_LINE, STYLE_DOT, 1);
  SetIndexBuffer(1, MinDay);
  SetIndexStyle (1, DRAW_LINE, STYLE_DOT, 1);
  SetIndexBuffer(2,MidDay);
  SetIndexStyle (2, DRAW_LINE, STYLE_DOT, 1);
  Comment("");
}

//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
void deinit() {
  Comment("");
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start() {
  double po, ph, pl, pc, x;
  int    currDay, i=0, j=0;

  if (Period()>60) {
    Comment(" i-DRProjections     4 !");
    return;
  }

  while (i<=NumberOfDay) {
    if (currDay!=TimeDay(Time[j])) {
      po = iOpen (NULL, 1440, i+1);
      ph = iHigh (NULL, 1440, i+1);
      pl = iLow  (NULL, 1440, i+1);
      pc = iClose(NULL, 1440, i+1);
      if (pc<po) x = (ph + pl + pc + pl) / 2;
      if (pc>po) x = (ph + pl + pc + ph) / 2;
      if (pc==po) x = (ph + pl + pc + pc) / 2;
      i++;
    }
    currDay = TimeDay(Time[j]);
    MaxDay[j] = x - pl;
    MinDay[j] = x - ph;
    MidDay[j]= (( x - pl)+ (x - ph))/2;
    j++;
  }
}
//+------------------------------------------------------------------+

